/*
 * SettingsController.java
 *
 * Created on July 22, 2007, 12:12 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.pythsoft;

import javax.microedition.rms.*;
import java.lang.String;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
 *
 * @author Administrator
 */
public class SettingsController {
    private RecordStore db = null;
    private static SettingsController ref = null;
    
    private SettingsController(){
        System.out.println("Creating SettingsController");
        try {
            RecordStore db = RecordStore.openRecordStore("getwbtsettings",true);
        } catch(RecordStoreException e) {
            System.out.println("Failed to open RecordStore: " + e.toString());
        }
        System.out.println("RecordStore "+ db.toString());
    }
    /** Creates a new instance of SettingsController */
    public static SettingsController getSettingsController() {
        if (ref == null)
            ref = new SettingsController();
        
        return ref;
    }
    
    public String getValue(int Id) {
        byte[] b;
        String s = "";
        try {
            b = db.getRecord(Id);
            s = new String(b);
        } catch (RecordStoreException rse) {
            System.out.println(rse.toString());
            rse.printStackTrace();
        }
        System.out.println("Returning" + s);
        return s;
    }
    
    public boolean setValue(String value, int Id) {
        System.out.println("Setting "+Id+" to "+value);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream outputStream = new DataOutputStream(baos);
	boolean status = true;
        System.out.println("Setting "+Id+" to "+value);
        try {
	    outputStream.writeUTF(value);
	}
	catch (IOException ioe) {
	    System.out.println(ioe);
	    ioe.printStackTrace();
            status = false;
	}
        byte[] b = baos.toByteArray();
        try {
        System.out.println("Setting "+Id+" to "+value+ " in "+ db.toString());
//            db.setRecord(Id, b, 0, b.length);
            db.addRecord(b, 0, b.length);
 System.out.println("done");       
            
        } catch (RecordStoreException rse) {
            System.out.println("Failed: " +rse.toString());
            rse.printStackTrace();
            status = false;
        }
        if (status)
            System.out.println("Set succesfully");
        else
            System.out.println("Failed to set");
 System.out.println("done");       
        return status;
    }
    
    public void close() {
        try {
            db.closeRecordStore();
        } catch (RecordStoreException rse) {
            System.out.println(rse.toString());
        }
    }
    
}
